$(document).ready(async function() {
    await loadServerOptions();
    await loadSavedGuilds();
});

async function loadServerOptions() {

    // Remove existing options
    $("#serverOptions").empty();

    // Deselect any selected option
    $("#serverOptions").val(null).trigger("change");

    // Fetch and append the server options
    try {
        const servers = await loadGuilds();
        servers.forEach(server => {
            $("#serverOptions").append($("<option>", {
                value: server.id,
                text: server.name,
                "data-icon": server.icon
            }));
        });
    }
    catch (error) {
        alert(error);
    }
}

async function loadSavedGuilds() {
    try {
        const servers = await getSavedGuilds();
        servers.forEach(server => {
            addServerTemplate(server.guild_id, server.name, server.icon);
        });
    }
    catch (error) {
        alert(error);
    }
}




function openServerModal() {
    $("#serverForm .modal").modal("show");
};

$("#deleteSelectedServerBtn").on("click", function() {
    alert("not implemented");
});

function selectServer(sideElem) {
    var name = sideElem.attr("data-name");
        guildId = sideElem.attr("data-guild-id");
        icon = sideElem.attr("data-icon");

    $("#selectedServerContainer .selected-server-name").text(name);
    $("#selectedServerContainer .selected-server-id").text(guildId);
    $("#selectedServerContainer .selected-server-icon").attr("src", `https://cdn.discordapp.com/icons/${guildId}/${icon}.webp?size=80`);
}

function addServer(serverName, serverId, serverIconHash) {
    var formData = new FormData();
    formData.append("name", serverName);
    formData.append("guild_id", serverId);
    formData.append("icon", serverIconHash);

    newSavedGuild(formData)
        .then(resp => {
            addServerTemplate(serverId, serverName, serverIconHash);
            console.log(JSON.stringify(resp, null, 4));
        })
        .catch(err => {
            alert(err);
            // alert(JSON.stringify(err, null, 4));
        })

}

$(document).ready(async function() {

    

    // getSavedGuilds()
    //     .then(resp => {
    //         console.log(JSON.stringify(resp, null, 4));
    //         for (i=0; i < resp.length; i++) {
    //             var guild = resp[i];
    //             addServerTemplate(guild.guild_id, guild.name, guild.icon);
    //         }
    //     })
    //     .catch(err => {
    //         alert(err);
    //     })

    // $.ajax({
    //     url: "/guilds",
    //     type: "GET",
    //     success: function(response) {
    //         for (i = 1; i < response.length; i++) {
    //             var guild = response[i];
    //             $("#serverOptions").append($("<option>", {
    //                 value: guild.id,
    //                 text: guild.name,
    //                 "data-icon": guild.icon
    //             }));
    //         }
    //     },
    //     error: function(response) {
    //         alert(JSON.stringify(response, null, 4));
    //     }
    // });
});

function addServerTemplate(serverId, serverName, serverIconHash) {
    template = $($("#serverItemTemplate").html());
    template.find("img").attr("src", `https://cdn.discordapp.com/icons/${serverId}/${serverIconHash}.webp?size=80`);
    template.attr("data-guild-id", serverId);
    template.attr("data-name", serverName);
    template.attr("data-icon", serverIconHash);
    $("#serverList").prepend(template);
}

$("#serverForm").on("submit", function(event) {
    event.preventDefault();

    var selectedOption = $("#serverOptions option:selected");
        serverName = selectedOption.text();
        serverId = selectedOption.val();
        serverIconHash = selectedOption.attr("data-icon");

    addServer(serverName, serverId, serverIconHash);

    $("#serverForm .modal").modal("hide");
    // alert(`${serverName} ${serverId} ${serverIconHash}`);
});